use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum HistogramFilterQuery {
    SearchText(String),
    Asset(super::super::scout::rids::api::AssetRid),
    Template(super::super::scout::rids::api::TemplateRid),
    Workbook(super::super::scout::rids::api::NotebookRid),
    DataReview(super::super::scout::rids::api::DataReviewRid),
    OriginType(super::SearchEventOriginType),
    DataReviewCheck(super::super::scout::rids::api::CheckRid),
    DispositionStatus(super::EventDispositionStatus),
    Priority(super::super::scout::api::Priority),
    Assignee(super::super::scout::rids::api::UserRid),
    EventType(super::EventType),
    CreatedBy(super::super::scout::rids::api::UserRid),
    Label(String),
    Property(super::super::api::Property),
    And(Vec<super::HistogramFilterQuery>),
    Or(Vec<super::HistogramFilterQuery>),
    Not(Box<super::HistogramFilterQuery>),
    Workspace(conjure_object::ResourceIdentifier),
    Procedure(conjure_object::ResourceIdentifier),
    ProcedureExecution(conjure_object::ResourceIdentifier),
    StepId(String),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for HistogramFilterQuery {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            HistogramFilterQuery::SearchText(value) => {
                map.serialize_entry(&"type", &"searchText")?;
                map.serialize_entry(&"searchText", value)?;
            }
            HistogramFilterQuery::Asset(value) => {
                map.serialize_entry(&"type", &"asset")?;
                map.serialize_entry(&"asset", value)?;
            }
            HistogramFilterQuery::Template(value) => {
                map.serialize_entry(&"type", &"template")?;
                map.serialize_entry(&"template", value)?;
            }
            HistogramFilterQuery::Workbook(value) => {
                map.serialize_entry(&"type", &"workbook")?;
                map.serialize_entry(&"workbook", value)?;
            }
            HistogramFilterQuery::DataReview(value) => {
                map.serialize_entry(&"type", &"dataReview")?;
                map.serialize_entry(&"dataReview", value)?;
            }
            HistogramFilterQuery::OriginType(value) => {
                map.serialize_entry(&"type", &"originType")?;
                map.serialize_entry(&"originType", value)?;
            }
            HistogramFilterQuery::DataReviewCheck(value) => {
                map.serialize_entry(&"type", &"dataReviewCheck")?;
                map.serialize_entry(&"dataReviewCheck", value)?;
            }
            HistogramFilterQuery::DispositionStatus(value) => {
                map.serialize_entry(&"type", &"dispositionStatus")?;
                map.serialize_entry(&"dispositionStatus", value)?;
            }
            HistogramFilterQuery::Priority(value) => {
                map.serialize_entry(&"type", &"priority")?;
                map.serialize_entry(&"priority", value)?;
            }
            HistogramFilterQuery::Assignee(value) => {
                map.serialize_entry(&"type", &"assignee")?;
                map.serialize_entry(&"assignee", value)?;
            }
            HistogramFilterQuery::EventType(value) => {
                map.serialize_entry(&"type", &"eventType")?;
                map.serialize_entry(&"eventType", value)?;
            }
            HistogramFilterQuery::CreatedBy(value) => {
                map.serialize_entry(&"type", &"createdBy")?;
                map.serialize_entry(&"createdBy", value)?;
            }
            HistogramFilterQuery::Label(value) => {
                map.serialize_entry(&"type", &"label")?;
                map.serialize_entry(&"label", value)?;
            }
            HistogramFilterQuery::Property(value) => {
                map.serialize_entry(&"type", &"property")?;
                map.serialize_entry(&"property", value)?;
            }
            HistogramFilterQuery::And(value) => {
                map.serialize_entry(&"type", &"and")?;
                map.serialize_entry(&"and", value)?;
            }
            HistogramFilterQuery::Or(value) => {
                map.serialize_entry(&"type", &"or")?;
                map.serialize_entry(&"or", value)?;
            }
            HistogramFilterQuery::Not(value) => {
                map.serialize_entry(&"type", &"not")?;
                map.serialize_entry(&"not", value)?;
            }
            HistogramFilterQuery::Workspace(value) => {
                map.serialize_entry(&"type", &"workspace")?;
                map.serialize_entry(&"workspace", value)?;
            }
            HistogramFilterQuery::Procedure(value) => {
                map.serialize_entry(&"type", &"procedure")?;
                map.serialize_entry(&"procedure", value)?;
            }
            HistogramFilterQuery::ProcedureExecution(value) => {
                map.serialize_entry(&"type", &"procedureExecution")?;
                map.serialize_entry(&"procedureExecution", value)?;
            }
            HistogramFilterQuery::StepId(value) => {
                map.serialize_entry(&"type", &"stepId")?;
                map.serialize_entry(&"stepId", value)?;
            }
            HistogramFilterQuery::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for HistogramFilterQuery {
    fn deserialize<D>(d: D) -> Result<HistogramFilterQuery, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = HistogramFilterQuery;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union HistogramFilterQuery")
    }
    fn visit_map<A>(self, mut map: A) -> Result<HistogramFilterQuery, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::SearchText, Some(Variant_::SearchText)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::SearchText(value)
                    }
                    (Variant_::Asset, Some(Variant_::Asset)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Asset(value)
                    }
                    (Variant_::Template, Some(Variant_::Template)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Template(value)
                    }
                    (Variant_::Workbook, Some(Variant_::Workbook)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Workbook(value)
                    }
                    (Variant_::DataReview, Some(Variant_::DataReview)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::DataReview(value)
                    }
                    (Variant_::OriginType, Some(Variant_::OriginType)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::OriginType(value)
                    }
                    (Variant_::DataReviewCheck, Some(Variant_::DataReviewCheck)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::DataReviewCheck(value)
                    }
                    (Variant_::DispositionStatus, Some(Variant_::DispositionStatus)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::DispositionStatus(value)
                    }
                    (Variant_::Priority, Some(Variant_::Priority)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Priority(value)
                    }
                    (Variant_::Assignee, Some(Variant_::Assignee)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Assignee(value)
                    }
                    (Variant_::EventType, Some(Variant_::EventType)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::EventType(value)
                    }
                    (Variant_::CreatedBy, Some(Variant_::CreatedBy)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::CreatedBy(value)
                    }
                    (Variant_::Label, Some(Variant_::Label)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Label(value)
                    }
                    (Variant_::Property, Some(Variant_::Property)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Property(value)
                    }
                    (Variant_::And, Some(Variant_::And)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::And(value)
                    }
                    (Variant_::Or, Some(Variant_::Or)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Or(value)
                    }
                    (Variant_::Not, Some(Variant_::Not)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Not(value)
                    }
                    (Variant_::Workspace, Some(Variant_::Workspace)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Workspace(value)
                    }
                    (Variant_::Procedure, Some(Variant_::Procedure)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Procedure(value)
                    }
                    (
                        Variant_::ProcedureExecution,
                        Some(Variant_::ProcedureExecution),
                    ) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::ProcedureExecution(value)
                    }
                    (Variant_::StepId, Some(Variant_::StepId)) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::StepId(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            HistogramFilterQuery::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::SearchText => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::SearchText(value)
                    }
                    Variant_::Asset => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Asset(value)
                    }
                    Variant_::Template => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Template(value)
                    }
                    Variant_::Workbook => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Workbook(value)
                    }
                    Variant_::DataReview => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::DataReview(value)
                    }
                    Variant_::OriginType => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::OriginType(value)
                    }
                    Variant_::DataReviewCheck => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::DataReviewCheck(value)
                    }
                    Variant_::DispositionStatus => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::DispositionStatus(value)
                    }
                    Variant_::Priority => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Priority(value)
                    }
                    Variant_::Assignee => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Assignee(value)
                    }
                    Variant_::EventType => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::EventType(value)
                    }
                    Variant_::CreatedBy => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::CreatedBy(value)
                    }
                    Variant_::Label => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Label(value)
                    }
                    Variant_::Property => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Property(value)
                    }
                    Variant_::And => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::And(value)
                    }
                    Variant_::Or => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Or(value)
                    }
                    Variant_::Not => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Not(value)
                    }
                    Variant_::Workspace => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Workspace(value)
                    }
                    Variant_::Procedure => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Procedure(value)
                    }
                    Variant_::ProcedureExecution => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::ProcedureExecution(value)
                    }
                    Variant_::StepId => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::StepId(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        HistogramFilterQuery::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    SearchText,
    Asset,
    Template,
    Workbook,
    DataReview,
    OriginType,
    DataReviewCheck,
    DispositionStatus,
    Priority,
    Assignee,
    EventType,
    CreatedBy,
    Label,
    Property,
    And,
    Or,
    Not,
    Workspace,
    Procedure,
    ProcedureExecution,
    StepId,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::SearchText => "searchText",
            Variant_::Asset => "asset",
            Variant_::Template => "template",
            Variant_::Workbook => "workbook",
            Variant_::DataReview => "dataReview",
            Variant_::OriginType => "originType",
            Variant_::DataReviewCheck => "dataReviewCheck",
            Variant_::DispositionStatus => "dispositionStatus",
            Variant_::Priority => "priority",
            Variant_::Assignee => "assignee",
            Variant_::EventType => "eventType",
            Variant_::CreatedBy => "createdBy",
            Variant_::Label => "label",
            Variant_::Property => "property",
            Variant_::And => "and",
            Variant_::Or => "or",
            Variant_::Not => "not",
            Variant_::Workspace => "workspace",
            Variant_::Procedure => "procedure",
            Variant_::ProcedureExecution => "procedureExecution",
            Variant_::StepId => "stepId",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "searchText" => Variant_::SearchText,
            "asset" => Variant_::Asset,
            "template" => Variant_::Template,
            "workbook" => Variant_::Workbook,
            "dataReview" => Variant_::DataReview,
            "originType" => Variant_::OriginType,
            "dataReviewCheck" => Variant_::DataReviewCheck,
            "dispositionStatus" => Variant_::DispositionStatus,
            "priority" => Variant_::Priority,
            "assignee" => Variant_::Assignee,
            "eventType" => Variant_::EventType,
            "createdBy" => Variant_::CreatedBy,
            "label" => Variant_::Label,
            "property" => Variant_::Property,
            "and" => Variant_::And,
            "or" => Variant_::Or,
            "not" => Variant_::Not,
            "workspace" => Variant_::Workspace,
            "procedure" => Variant_::Procedure,
            "procedureExecution" => Variant_::ProcedureExecution,
            "stepId" => Variant_::StepId,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the HistogramFilterQuery union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
